/* Copyright IBM Corporation 1988,1991 - All Rights Reserved */

/*
	$Disclaimer: This software is part of version 7.2 of the 
Andrew User Interface System and is the 
property of IBM, Carnegie Mellon University, 
and the other copyright holders.  The source 
code of this version is for the sole use of 
members of the Andrew Consortium with 
memberships extending into calendar year 
1994.  This source code is not to be distributed 
to non-members of the consortium nor beyond 
a fifty-mile radius from the membership address.  
Binary object code compiled or derived from 
these sources is not to be distributed to non-
members.  Members may have additional 
distribution rights granted by prior written 
permission of Carnegie Mellon University.

IBM, CARNEGIE MELLON UNIVERSITY, 
AND THE OTHER COPYRIGHT HOLDERS
 DISCLAIM ALL WARRANTIES WITH 
REGARD TO THIS SOFTWARE, INCLUDING 
ALL IMPLIED WARRANTIES OF MERCHANT-
ABILITY AND FITNESS. IN 
NO EVENT SHALL  IBM, CARNEGIE 
MELLON UNIVERSITY, OR ANY OTHER 
COPYRIGHT HOLDER BE LIABLE FOR 
ANY SPECIAL, INDIRECT OR CONSE-
QUENTIAL DAMAGES OR ANY DAMAGES 
WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT 
OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
 $
*/

/* For full copyright information see:'andrew/config/COPYRITE' */

XCOMM 
XCOMM  The following is from the allsys.mcr file, and may be over-ridden
XCOMM  by the platform-specific system.mcr file or the
XCOMM  site-specific site.mcr file.
XCOMM 

/* System-independent macros: included at the head of system.mcr. */

/* XBASEDIR should point to the top of an X11 installation */
/* if you haven't installed X11, you can carefully set everything below */
/* that uses XBASEDIR to point to the right places */
        XBASEDIR = 
/* XSRCDIR should be an absolute path to the top of an X11 source tree */
/* it is only used for getting imake and makedepend (and fc under X11R2) */
/* if you have imake and makedepend installed somwhere, you can leave */
/* this blank and take care of imake and makedepend (and fc) below */
        XSRCDIR = 

#ifdef AFS_ENV
/* AFSBASEDIR should point to the top of an AFS installation. */
/* Thus, $(AFSBASEDIR)/lib/afs $(AFSBASEDIR)/include/afs should both exist. */
/* for historical reasons the default is set to /usr/andy; */
/* if you need to change this setting, you can do so in site.h . */
        AFSBASEDIR = /usr/andrew
#endif /* AFS_ENV */

/* If your AFS protection server relies on the MIT Athena Kerberos */
/* library, set KRBLIB to name where the Kerberos library lives. */
/* You will also need to define this variable if you make the MIT neos
application */
        KRBLIB = 

/* set DESTDIR to where you want Andrew installed */
/* it is necessary that it be installed incrementally, while it is built */
/* DEFAULT_ANDREWDIR_ENV is set in the allsys.h file to the location where */
/* DESTDIR will be visible by users after installation.  If this is different */
/* from the location where it will be installed incrementally at build time, */
/* set BASEDIR to that latter location by redefining it in your site.h file. */
        BASEDIR = DEFAULT_ANDREWDIR_ENV
        DESTDIR = ${BASEDIR}

/* XBINDIR is for programs installed in the X bin directory*/

        XBINDIR = /usr/bin/X11

/* XUTILDIR is for programs that have been installed in some place other */
/* than the standard location - the ITC uses it for 'makedepend' and 'imake' */
        XUTILDIR = /usr/bin/X11

/* CDEBUGFLAGS are passed to C compilations.  */
/* To generate debugger symbol tables, use -g instead of -O.  */
        CDEBUGFLAGS = -O

/* MAKEDODEBUG determines whether .dog files are generated from makedo. */
/* Set it to -g to generate them.  You must set CDEBUGFLAGS to -g as well. */
        MAKEDODEBUG = 

        SHELL = /bin/sh
        CSHELL = /bin/csh

        CC = gcc
        CPPC = g++
        LOCALDIR = DEFAULT_LOCALDIR_ENV
        GCCLIB = "$(LOCALDIR)/lib/gcc-lib/rs6000-ibm-aix/2.3.3/libgcc.a"

        GENREFS = $(BASEDIR)/etc/grefs
        REFSNM = /bin/nm

/* Malloc will generate addresses divisible by MALLOCALIGNMENT,  */
/* which must be a multiple of 4 */
        MALLOCALIGNMENT = 4


/* Specify the default standard C library. */
#ifdef CMUCS
        CRT0PATH = /usr/cs/lib/crt0.o
        CLIB = /usr/cs/lib/libc.a
#else /* CMUCS */
        CRT0PATH = /lib/crt0.o
        CLIB = /lib/libc.a
#endif /* CMUCS */

/* Check and Set the RESOLVELIB path below */
/* There are at least two sources of libresolv.a */
/* 1) 4.3 distribution */
/* 2) bind distribution */
/* At CMU we use the bind distribution of libresolv.a */
#ifdef RESOLVER_ENV
/* if in a separate library: */
/*      RESOLVLIB = /usr/lib/libresolv.a
/* if in /lib/libc.a: */
        RESOLVLIB =
#else /* RESOLVER_ENV */
        RESOLVLIB =
#endif /* RESOLVER_ENV */

/* the following variable is for any libraries
 * needed for networking support
 */
        NETLIBS =
/* this is to catch machine-specific libraries that contain
 * fixes for various functions
 */
        SUPLIBS =

/* AT&T SYSV shared library support library */
#if defined(LIBDL_ENV)
        DYN_LINK_LIB = -ldl
#endif 

/* The Lex library macro.  System that define FLEX_ENV now: i386_Linux, i386_BSD */
#ifdef FLEX_ENV
LEXLIB = -fl
#else
LEXLIB = -ll
#endif

/* uncomment this if your make program has MAKEFLAGS but not MFLAGS */
/* #define ConstructMFLAGS */

        ADDALIASES = $(BASEDIR)/etc/addalias
        CLASS = ${BASEDIR}/bin/class

#ifdef HAVE_DYNAMIC_LOADING
DYNEXELIBS = $(BASEDIR)/lib/libATKDynLoad.a $(BASEDIR)/lib/libATKLink.a
#else
DYNEXELIBS =
#endif
DYNMAIN = ,DynM.$$$$
DYNEXT = +
TMPDYNEXT = +
POSTDYNFLAGS = -L$(BASEDIR)/dlib/atk
DYNPOSTPROCESS =@true
DYNLINKPROG = $(LINKPREFIX) $(CPPC)
MKDYNMAIN = $(BASEDIR)/etc/mkdynmain

/* going away */
        MAKEDO = 
        MAKEDOFLAGS = 
        DOINDEX = 
        CLASSINCLUDES = 
/* going away */

        REGISTER=$(BASEDIR)/bin/cregister
        XINCDIR = $(XBASEDIR)/usr/include
#ifdef AFS_ENV
  INCLUDES =  -I${BASEDIR}/include/atk -I${BASEDIR}/include -I$(AFSBASEDIR)/include -I${XINCDIR}
#else /* AFS_ENV */
INCLUDES =  -I${BASEDIR}/include/atk -I${BASEDIR}/include -I${XINCDIR}
#endif /* AFS_ENV */
        DEPENDSCRIPT = $(TOP)/config/depend.csh
        XMAKEDEPEND = $(XUTILDIR)/makedepend
        IMAKE = $(XUTILDIR)/imake
        XLIBDIR = $(XBASEDIR)/usr/lib
        OLDXLIB = $(XLIBDIR)/liboldX.a
        IRULESRC = $(TOP)/config
        FDBWM = $(BASEDIR)/bin/fdbwm
        FDBBDF = $(BASEDIR)/bin/fdbbdf

        MACH = and

        TOP = TOPDIR
        AS = as
        CPP = /lib/cpp
        LD = ld
        LINT = lint
#ifdef BUILDANDREWINSTALL_ENV
        INSTALL = $(BASEDIR)/etc/install
#else /* BUILDANDREWINSTALL_ENV */
        INSTALL = install
#endif /* BUILDANDREWINSTALL_ENV */
        TAGS = ctags
        RM = rm -f
        MV = mv
        CP = cp
        LN = ln -s
        RANLIB = ranlib
        AR = ar clq
        ARDEL = ar d
        CHMODW = chmod +w
        LS = ls
        AWK = awk
        SORT = sort
        TR = tr
        NM = nm
        MAKE = make
        SED = sed
        LEX = lex
        YACC = yacc
        SCRIBE = scribe
        LINTOPTS = -axz
        LINTLIBFLAG = -C
        STD_DEFINES =

XCOMM  This MATHLIB macro is a workaround for a bug in HPUX8.0 ld.
XCOMM  That loader has problems linking normal archive libraries
XCOMM  into a shared library.  [console/cmd, ness/objects]
XCOMM  This macro is made empty in the appropriate hp system.mcr
XCOMM  files.
        MATHLIB = -lm


/* If there is already a JPEG distribution at your site, #undefine MK_JPEG and set these two macros to point to the JPEG library and include files */

JPEGLIBDIR=$(BASEDIR)/lib
        JPEGLIB =$(JPEGLIBDIR)/libjpeg.a
XCOMM         JPEGINCLUDES = ${BASEDIR}/include

/* If there is already a TIFF distribution at your site, #undefine MK_TIFF and set these two macros to point to the TIFF library and include files */

TIFFLIBDIR=$(BASEDIR)/lib
        TIFFLIB = $(TIFFLIBDIR)/libtiff.a
XCOMM         TIFFINCLUDES = -I${BASEDIR}/include

#ifdef mips 
ASMPP_CC = $(CC) -E
AS_FLAGS = -nocpp
#else		/* mips */
#ifdef SCOunix
ASMPP_CC = $(CPP)
AS_FLAGS =
#else		/* SCOunix */
#ifdef GNU_ENV
ASMPP_CC = $(CPP)
AS_FLAGS =
#else		/* GNU_ENV */ /* DEFAULT */
ASMPP_CC = $(CC) -E
AS_FLAGS =
#endif		/* GNU_ENV */
#endif		/* SCOunix */
#endif		/* mips */

#define SelectATKLib(name) @@\
Concat(lib,name)=Concat(lib,name).a @@\
Concat(OptionalLib,name)=install.time

#define DeSelectATKLib(name) @@\
Concat(lib,name) =  @@\
Concat(OptionalLib,name)=Concat(install.lib,name)

#include <libs.mcr>

/* the directories where the lists of packages and their location variables are stored */
LOCALPACKAGEDIRS=
STDPACKAGEDIRS=$(BASEDIR)/lib/packages $(BASEDIR)/lib/packages/atk

FULLATKDLIBDIR=$(DESTDIR)ATKDLIBDIR
XCOMM 
XCOMM  End of what comes from the allsys.mcr file.
XCOMM 
