/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 7.2 of the 
 * Andrew User Interface System and is the 
 * property of IBM, Carnegie Mellon University, 
 * and the other copyright holders.  The source 
 * code of this version is for the sole use of 
 * members of the Andrew Consortium with 
 * memberships extending into calendar year 
 * 1994.  This source code is not to be distributed 
 * to non-members of the consortium nor beyond 
 * a fifty-mile radius from the membership address.  
 * Binary object code compiled or derived from 
 * these sources is not to be distributed to non-
 * members.  Members may have additional 
 * distribution rights granted by prior written 
 * permission of Carnegie Mellon University.
 * 
 * IBM, CARNEGIE MELLON UNIVERSITY, 
 * AND THE OTHER COPYRIGHT HOLDERS
 *  DISCLAIM ALL WARRANTIES WITH 
 * REGARD TO THIS SOFTWARE, INCLUDING 
 * ALL IMPLIED WARRANTIES OF MERCHANT-
 * ABILITY AND FITNESS. IN 
 * NO EVENT SHALL  IBM, CARNEGIE 
 * MELLON UNIVERSITY, OR ANY OTHER 
 * COPYRIGHT HOLDER BE LIABLE FOR 
 * ANY SPECIAL, INDIRECT OR CONSE-
 * QUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT 
 * OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *  $
*/

#ifndef NORCSID
#define NORCSID
static char rcsid[]="$Header: /usr/user/auis-7.2/overhead/mail/lib/RCS/locnamex.c,v 2.7 1992/12/15 21:04:17 rr2b R6tape $";
#endif

/*
	locnamex.c -- Deallocator for low-level resolver of local addresses
*/

#include <stdio.h>
#include "mail.h"

void la_FreeMD(MD)
struct MailDom *MD;
{/* Somebody's about to erase the pointer MD. */

    if (MD != NULL && (--(MD->Refs)) == 0) {	/* Keep the reference count */
	if (MD->Next != NULL && MD->Prev != NULL) {
	    MD->Next->Prev = MD->Prev;
	    MD->Prev->Next = MD->Next;
	}
	if (MD->Orig != NULL) free(MD->Orig);
	if (MD->Final != NULL) free(MD->Final);
	if (MD->FwdPrefs != NULL) free(MD->FwdPrefs);
	if (MD->Fwds != NULL) {
	    if (MD->Fwds[0] != NULL) free(MD->Fwds[0]);
	    free(MD->Fwds);
	}
	free(MD);
    }
}
