/* Copyright 1993 Carnegie Mellon University All rights reserved.
  $Disclaimer: This software is part of version 7.2 of the 
 * Andrew User Interface System and is the 
 * property of IBM, Carnegie Mellon University, 
 * and the other copyright holders.  The source 
 * code of this version is for the sole use of 
 * members of the Andrew Consortium with 
 * memberships extending into calendar year 
 * 1994.  This source code is not to be distributed 
 * to non-members of the consortium nor beyond 
 * a fifty-mile radius from the membership address.  
 * Binary object code compiled or derived from 
 * these sources is not to be distributed to non-
 * members.  Members may have additional 
 * distribution rights granted by prior written 
 * permission of Carnegie Mellon University.
 * 
 * IBM, CARNEGIE MELLON UNIVERSITY, 
 * AND THE OTHER COPYRIGHT HOLDERS
 *  DISCLAIM ALL WARRANTIES WITH 
 * REGARD TO THIS SOFTWARE, INCLUDING 
 * ALL IMPLIED WARRANTIES OF MERCHANT-
 * ABILITY AND FITNESS. IN 
 * NO EVENT SHALL  IBM, CARNEGIE 
 * MELLON UNIVERSITY, OR ANY OTHER 
 * COPYRIGHT HOLDER BE LIABLE FOR 
 * ANY SPECIAL, INDIRECT OR CONSE-
 * QUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT 
 * OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *  $
 */

#include <andrewos.h>

#include <util.h>

int main(int argc, char **argv)
{
    int i, len;
    char *r;
    for(i=1;i<argc;i++) {
	if(strcmp(argv[i], "andrewdir")==0) r=AndrewDir("");
	else if(strcmp(argv[i], "afsbasedir")==0) {
	    r=getenv("AFSBASEDIR");
	    if(r==NULL) r=AFSBASEDIR;
	} else if (strcmp(argv[i], "xbasedir")==0) r=XBaseDir("");
	else if (strcmp(argv[i], "localdir")==0) r=LocalDir("");
	else if (strcmp(argv[i], "andydir")==0) r=AndyDir("");
	if(r && (len=strlen(r))>0 && r[len-1]!='/') strcat(r, "/");
	printf("%s\n", r);
    }
    return 0;
}
